//Testroutine fr Steuerung: Nach Einschalten werden die Eingnge 3x ein und ausgeschalten, 
//danach kann mit den Eingabetasten der jeweilige Ausgang getestet werden, auerdem luft ein Testprogramm
//fr das LCD an Port C

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <util/delay.h>
#include "lcd.h"
#include "clock.h"
#include "usart.h"
#include "config.h"
#include "ds1821.h"


#define FALSE 0
#define TRUE 1


#define TI_DCF 1
#define TI_TEMP 10			                	//Tasktimer der LCD Testroutine








volatile uint8_t wartezeit;
volatile uint8_t DCF_TIMER;
volatile uint8_t TEMP_TIMER;


void DCF_ANZEIGE (void);							//Deklaration der LCD Testfunktion







ISR(TIMER0_OVF_vect) 					// Interrupt alle Millisekunde
{
	static uint16_t sekunden = 1000;

	TCNT0=131;							//Preloader um 1ms zu erreichen

	
	
	
	//Millisekunden Timer---------------

	//Tasktimer dekrementieren bis sie null sind
	
	if (DCF_TIMER) DCF_TIMER--;	
	if (TEMP_TIMER) TEMP_TIMER--;


	

	
	if (--sekunden == 0)				//zuerst dekrementieren, dann schauen ob 0
	{
		sekunden = 1000;				//1000 ms laden um Sekundentakt zu erreichen
		if (wartezeit) wartezeit--;
		
		//if (TEMP_TIMER) TEMP_TIMER--;
			//Wartezeit dekrementieren wenn nicht null
		
	
	}
		

}

int main(void)
{
	//---- Initialisierung Port IO -------------------------------

	DDRB = 0xFF;						// Ganzen Port B auf Ausgang schalten
	PORTB = 0xFF;						// Initialisieren der Richtungsanzeige

	DDRC = 0x80;     					// Pin 8 von Port C auf Eingang, Rest auf Ausgang fr LCD

	
	// --- Timer 0 Initialisierung (fr ATMega8515 im Normal Mode) ---------------------------------------
	//
	
	TCCR0= (1<<CS01) | (1<<CS00); 		// Mode: Normal, Timer 0 Takt: CLK / 64			
	TCNT0 = 131;				  		// Count Register laden (17,36 s * 58 ergibt ca. 1 ms)
	TIMSK = (1<<TOIE0);			  		// Timer 0 Output Compare Interrupt freigeben		

	
	Start_Clock();
	//THERMOMETER();

	lcd_init(LCD_DISP_ON);		  		//Initialisierung LCD		
	lcd_clrscr();		  	

       	
	
	sei();						  		// globale Interruptfreigabe



	while (1)
	
		{
			if (DCF_TIMER ==0)				//wenn Tasktimer fr LCD Test gleich null
				{
					DCF_TIMER = TI_DCF;			//Tasktimer wieder laden	
					DCF_ANZEIGE();					//LCD Test ausfhren
				}

			if (TEMP_TIMER ==0)
				{	
					TEMP_TIMER = TI_TEMP;
					THERMOMETER();
				}
	
	}

	return 0;
}

//---------------------------Blinktask------------------------------------------------------------------

	
//-----------------------------------LCD Testroutine----------------------------------------------------------			
		
		

		void DCF_ANZEIGE (void)

		{
				
			char buffer[10];
			char temp_buffer[10];

			lcd_gotoxy(0,0);
			lcd_puts("Time:");
			itoa(hh,buffer,10);
			lcd_gotoxy(6,0);
			if (hh<10)
			lcd_puts("0");
			lcd_puts(buffer);
			lcd_gotoxy(8,0);
			lcd_puts(":");

			itoa(mm,buffer,10);
			if (mm<10)
			lcd_puts("0");
			lcd_puts(buffer);
			lcd_gotoxy(11,0);
			lcd_puts(":");

			itoa(ss,buffer,10);
			if (ss<10)
			lcd_puts("0");
			lcd_puts(buffer);
			lcd_gotoxy(12,0);
		
				
			itoa (flags.dcf_sync, buffer, 10);
			if (flags.dcf_sync)
				{
					lcd_gotoxy(4,3);
					lcd_puts("OK    ");
				}
			else
				{
					lcd_gotoxy(4,3);
					lcd_puts("NO SIG");
				}

			
			lcd_gotoxy(0,1);
			lcd_puts("Date:");
			itoa (day, buffer, 10);
			lcd_gotoxy(6,1);
			if (day<10)
			lcd_puts ("0");
			lcd_puts(buffer);
			lcd_gotoxy(8,1);
			lcd_puts(".");

			itoa (mon, buffer, 10);
			if (mon<10)
			lcd_puts("0");
			lcd_puts(buffer);
			lcd_gotoxy(11,1);
			lcd_puts(".");

			itoa(year, buffer, 10);
			if (year<10)
			lcd_puts("0");
			lcd_puts(buffer);
			lcd_gotoxy(15,3);
			
		
			itoa (flags.dcf_rx, buffer, 10);
			lcd_puts (buffer);


			
			lcd_gotoxy(0,2);
			lcd_puts("WaterTemp:");
			lcd_gotoxy(15,2);
			lcd_puts("C");
			lcd_gotoxy(0,3);
			lcd_puts("DCF:");

			lcd_gotoxy( 10,2 );
		   	sprintf( s, "%3d.%d", t, r );
		   	lcd_puts( s );

			

			
		}

		


			
